#include "fxlib.h"
#include "windows.h"
#include "MonochromeLib.h"
#include "jeux.h"
#include <stdio.h>
#include <stdlib.h>

// Fichier sauvegarde progression
FONTCHARACTER filename[]={'\\','\\','f','l','s','0','\\','m','o','o','n','r','.','t','x','t',0};

int handle, key, avancement, etape, vaise;


int AddIn_main(int isAppli, unsigned short OptionNum)
{
	int choix, reussi;
	demarrage();
	do{
		choix=menu();
		if(choix==1){
			reussi=0;
			if(etape==1) reussi=jeu1(vaise);
			if(etape==2) reussi=jeu2(vaise);
			if(etape==3) reussi=jeu3(vaise);
			if(etape==4) reussi=jeu4(vaise);
			if(etape==5) reussi=jeu5(vaise);
			//if(etape==6) reussi=jeu6();
			//if(etape==7) reussi=jeu7();
			if(reussi==1 && etape!=5) etape++;
			if(etape>avancement) avancement=etape;
			ecrire_avancement();
		}
		if(choix==2) options();
	}while(choix!=3);
	quitter();
    return 1;
}

// ######### fonctions secondaires ########

// Menu principal
menu()
{
	int ligne=1;
	char fuseedroite[]={0,0,224,126,63,126,224,0};// fusée vers la droite
	char cratere[]={24,102,66,153,153,66,102,24};// cratere lunaire
	char astrodebout[]={24,36,36,24,126,24,36,36};// astronaute_debout
	char aliendebout[]={126,90,60,24,24,36,36,66};  // alien_debout
	
	Bdisp_AllClr_DDVRAM();
	ML_line(49, 4, 49, 11, ML_BLACK);
	ML_line(49, 4, 51, 6, ML_BLACK);
	ML_line(52, 6, 54, 4, ML_BLACK);
	ML_line(54, 4, 54, 11, ML_BLACK);
	ML_bmp_8_or(cratere, 56, 4);
	ML_bmp_8_or(cratere, 65, 4);
	ML_line(74, 4, 74, 11, ML_BLACK);
	ML_line(75, 6, 77, 8, ML_BLACK);
	ML_line(78, 4, 78, 11, ML_BLACK);
	PrintMini(46,13,"OPERATION",0);
	windows_2(38,22,88,34);
	PrintMini(54,26,"JOUER",0);
	windows_2(38,36,88,48);
	PrintMini(49,40,"OPTIONS",0);
	windows_2(38,50,88,62);
	PrintMini(49,54,"QUITTER",0);
	SaveDisp(1);
	
	do{
		ML_clear_vram();
		RestoreDisp(1);
		ML_rectangle(39, 9+14*ligne, 87, 19+14*ligne, 1, ML_CHECKER, ML_TRANSPARENT);
		GetKey(&key);
		if(key==30018 && ligne!=1) ligne--;
		if(key==30023 && ligne!=3) ligne++;
	}while(key!=30004);
	return ligne;
}

// Menu options
options()
{
	char affichage[10];
	char cle1[]={0,0,103,29,103,0,0,0};// cle a pipe
	char cle2[]={0,0,115,92,115,0,0,0};// cle a pipe
	char cadena[]={56,40,40,124,108,108,124,0};// cadena
	char astrodebout[]={24,36,36,24,126,24,36,36};// astronaute_debout
	int i,y,nbr;
	lecture_avancement();
	Bdisp_AllClr_DDVRAM();
	ML_horizontal_line(7, 0, 127, ML_BLACK);
	ML_bmp_8_or(cle1, 35, 0);
	ML_bmp_8_or(cle2, 85, 0);
	PrintMini(50,1,"OPTIONS",0);
	PrintMini(10,12,"ETAPE:",0);
	// Affichage des carre de selecion pour etape
	for(i=1;i<=8;i++){
		sprintf(affichage,"%d",i);
		if(avancement<i) ML_bmp_8_or(cadena, 2+12*i, 22);
		else PrintXY(3+12*i, 22, affichage, 0);
	}
	
	Bdisp_SetPoint_VRAM(54,47,1);
	Bdisp_SetPoint_VRAM(66,47,1);
	Bdisp_SetPoint_VRAM(67,47,1);
	Bdisp_SetPoint_VRAM(65,47,1);
	Bdisp_SetPoint_VRAM(66,48,1);
	Bdisp_SetPoint_VRAM(66,46,1);
	
	PrintMini(10,35,"REINITIALISER",0);
	PrintMini(10,45,"VAISEAU:",0);
	PrintMini(10,55,"RETOUR",0);
	nbr=1;
	SaveDisp(1);
	do{
		Bdisp_AllClr_DDVRAM();
		RestoreDisp(1);
		if(key==30018 && nbr!=1) nbr--;
		if(key==30023 && nbr!=4) nbr++;
		if(nbr==1){
			if(key==30020 && etape!=1) etape--;
			if(key==30021 && etape!=avancement) etape++;
		}
		if(nbr==3){
			if(key==30020 && vaise!=1) vaise=1;
			if(key==30021 && vaise!=2) vaise=2;
		}
		if(nbr==1) y=10;
		if(nbr==2) y=33;
		if(nbr==3) y=43;
		if(nbr==4) y=53;
		ML_bmp_8_or(astrodebout, 0, y);
		for(i=1;i<=8;i++){
			if(etape==i) ML_rectangle(1+12*i, 20, 10+12*i, 30, 1, ML_CHECKER, ML_TRANSPARENT);
			else ML_rectangle(1+12*i, 20, 10+12*i, 30, 1, ML_BLACK, ML_TRANSPARENT);
		}
		for(i=4;i<=5;i++){
			if(vaise+3==i) ML_rectangle(1+12*i, 42, 10+12*i, 52, 1, ML_CHECKER, ML_TRANSPARENT);
			else ML_rectangle(1+12*i, 42, 10+12*i, 52, 1, ML_BLACK, ML_TRANSPARENT);
		}
		GetKey(&key);
		if(nbr==2 && key==30004){
			if(reinitialiser()==1) nbr=3, key=30004;
		}
	}while(key!=30004 || nbr!=4);
	ecrire_avancement();
}



// ####### Fonctions complementaires ######

// reinitialise les données contenues dans le fichier
reinitialiser()
{
	int nbr=77;
	Bdisp_AllClr_DDVRAM();
	windows_2(5,5,124,36);
	PrintMini(43,10,"ATTENTION !",0);
	PrintMini(10,18,"VEUX-TU VRAIMENT SUPPRIMER",0);
	PrintMini(22,26,"TOUTE TA PROGRESSION ?",0);
	PrintMini(30,40,"OUI",0);
	PrintMini(85,40,"NON",0);
	do{
		PrintMini(nbr,40,">",0);
		GetKey(&key);
		PrintMini(nbr,40," ",0);
		if(key==30020) nbr=22;
		if(key==30021) nbr=77;
	}while(key!=30004);
	if(nbr==22){
		avancement=1;
		etape=1;
		return 1;
	}
	else return 0;
}

// fermeture du fichier + message de fin
quitter()
{
	int i;
	Bfile_CloseFile(handle);
	Bdisp_AllClr_DDVRAM();
	windows_3(10,25,120,37);
	PrintMini(14,29,"HUSTON ON A UN PROBLEME !",0);
	Bdisp_PutDisp_DD();
	Sleep(1000);
	for(i=1;i<100;i++){
		ML_circle(63, 31, i, ML_BLACK);
		ML_circle(63, 31, i-5, ML_WHITE);
		Bdisp_PutDisp_DD();
		Sleep(10);
	}
	Bdisp_AllClr_DDVRAM();
}

// ouverture du fichier plus ecran acceuil
demarrage()
{
	char fuseedroite[]={0,0,224,126,63,126,224,0};// fusée vers la droite
	char cratere[]={24,102,66,153,153,66,102,24};// cratere lunaire
	char astrodebout[]={24,36,36,24,126,24,36,36};// astronaute_debout
	char aliendebout[]={126,90,60,24,24,36,36,66};  // alien_debout
	int i;
	Bdisp_AllClr_DDVRAM();
	handle = Bfile_OpenFile(filename,_OPENMODE_READWRITE);
	if(handle == -1){
		Bfile_CreateFile(filename, 8);
		do{
			handle = Bfile_OpenFile(filename,_OPENMODE_READWRITE);
		}while(handle==-1);
		avancement=etape=vaise=1;
		Sleep(100);
		ecrire_avancement();
		Bdisp_AllClr_DDVRAM();
		windows_2(2,6,124,42);
		PrintMini(35,10,"Premiere fois ?",0);
		PrintMini(20,17,"Un fichier a ete cree:",0);
		PrintMini(42,25,"monr.txt",0);
		PrintMini(6,33,"Merci de ne pas le supprimer",0);
		PrintMini(45,55,"PRESS [EXE]",0);
		do{
			GetKey(&key);
		}while(key!=30004);
	}
	lecture_avancement();
	ML_clear_vram();
	ML_line(49, 29, 49, 36, ML_BLACK);
	ML_line(49, 29, 51, 31, ML_BLACK);
	ML_line(52, 31, 54, 29, ML_BLACK);
	ML_line(54, 29, 54, 36, ML_BLACK);
	ML_bmp_8_or(cratere, 56, 29);
	ML_bmp_8_or(cratere, 65, 29);
	ML_line(74, 29, 74, 36, ML_BLACK);
	ML_line(75, 31, 77, 33, ML_BLACK);
	ML_line(78, 29, 78, 36, ML_BLACK);
	PrintMini(46,38,"OPERATION",0);
	SaveDisp(1);
	for(i=0;i<130;i++){
		ML_clear_vram();
		RestoreDisp(1);
		ML_rectangle(127, 0, i, 63, 0, ML_WHITE, ML_WHITE);
		ML_bmp_8_or_cl(fuseedroite, i, 29);
		ML_display_vram();
		Sleep(20);
	}
	PrintMini(45,55,"PRESS [EXE]",0);
	ML_bmp_8_or_cl(astrodebout, 36, 53);
	ML_bmp_8_or_cl(aliendebout, 87, 53);
	do{
		GetKey(&key);
	}while(key!=30004);
}


// ####### Gestion du fichier #######

ecrire_avancement()
{
	char buffer[7];
	sprintf(buffer,"%d-%d-d",avancement,etape,vaise);
	Bfile_CloseFile(handle);
	Bfile_DeleteFile(filename);
	Bfile_CreateFile(filename, 8);
	handle = Bfile_OpenFile(filename,_OPENMODE_READWRITE);
	Bfile_WriteFile(handle,buffer,3);
}

lecture_avancement()
{
	char buffer[7];
	Bfile_ReadFile(handle,buffer,7,0);
	switch(buffer[0]){
		case '0': avancement=0;
		break;
		case '1': avancement=1;
		break;
		case '2': avancement=2;
		break;
		case '3': avancement=3;
		break;
		case '4': avancement=4;
		break;
		case '5': avancement=5;
		break;
		case '6': avancement=6;
		break;
		case '7': avancement=7;
		break;
		case '8': avancement=8;
		break;
		case '9': avancement=9;
		break;
	}
	switch(buffer[2]){
		case '0': etape=0;
		break;
		case '1': etape=1;
		break;
		case '2': etape=2;
		break;
		case '3': etape=3;
		break;
		case '4': etape=4;
		break;
		case '5': etape=5;
		break;
		case '6': etape=6;
		break;
		case '7': etape=7;
		break;
		case '8': etape=8;
		break;
		case '9': etape=9;
		break;
	}
	switch(buffer[4]){
		case '0': vaise=0;
		break;
		case '1': vaise=1;
		break;
	}
}


#pragma section _BR_Size
unsigned long BR_Size;
#pragma section
#pragma section _TOP
int InitializeSystem(int isAppli, unsigned short OptionNum){ return INIT_ADDIN_APPLICATION(isAppli, OptionNum);}
#pragma section

// sprites
/*
char astro_debout[]={24,36,36,24,126,24,36,36};  // astronaute_debout
char astro_droite[]={0,16,214,57,57,214,26,0};   // astronaute_droite
char alien_debout[]={126,90,60,24,24,36,36,66};  // alien_debout
char alien_droite[]={0,131,101,31,31,101,131,0}; // alien_droite
char asteroide_1[]={96,158,129,129,129,66,36,24};// asteroide numero 1
char asteroide_2[]={48,76,130,129,65,33,18,12};  // asteroide numero 2
char fusée_debout[]={8,28,28,28,28,62,52,32}; 	 // fusée vers le haut
char fusée_droite[]={0,0,224,126,63,126,224,0};  // fusée vers la droite
char cratere[]={24,102,66,153,153,66,102,24};    // cratere lunaire
char cle1[]={0,0,103,29,103,0,0,0};				 // cle a pipe
char cle2[]={0,0,115,92,115,0,0,0};				 // cle a pipe
char cadena[]={0,56,40,40,124,108,108,124};		 // cadena
*/
