#define XMAX 127
#define YMAX 63
// Terre
#define XTA 63
#define XTB 90
#define YT 31
#define RAYT 4
// Zone GEO aproximative
#define RGEOMIN 22
#define RGEOMAX 30
// Nombre de points successifs OK pour succès Mise à poste GEO
#define NBPOKGEO 400
// Constante gravitationnelle simplifiée GMMT tq: F = GMMT / r2
#define GMMT 10
// Coef Vitesse Realiste
#define COEFR 7.5

// Lune
#define XL 30
#define YL 31
#define RAYL 2
// Constante gravitationnelle simplifiée GMML tq: F = GMML / r2
#define GMML 2

// Manoeuvres (incrément de base)
#define DVINC 0.03

#define YVITESSE 51

int etape1(int vaiso);
int etape2(int vaiso);
int etape3(int vaiso);
int etape4(int vaiso);
int etape5(int vaiso);
int anime12( double x, double y, double vx, double vy, int tmax);
int anime3(double x, double y, double vx, double vy, int tmax);
int anime4(double x, double y, double vx, double vy, int tmax);
int anime5(double x, double y, double vx, double vy, int tmax);

int integreUnPasTerre(double x, double y, double vx, double vy, double *valeurs);
int integreUnPasTerreLune(double x, double y, double vx, double vy, double *valeurs);
int forceSubie(double Gm1m2, double xc, double yc, double x, double y, double *force);

int crashed(double RayCorps, double xc, double yc, double x, double y);
int GeoOK(double x, double y);

int affiche_vaisseau(int x, int y);

int RTC_getTicks();
int rand_int(int max);