#include "fxlib.h"
#include "windows.h"

#ifdef ALL_WINDOWS
	#define WINDOWS_1
	#define WINDOWS_2
	#define WINDOWS_3
	#define WINDOWS_4
#endif

#ifdef WINDOWS_1
	void windows_1(int x1, int y1, int x2, int y2)
	{	
		// Contours externes
		Bdisp_DrawLineVRAM(x1,y1,x2,y1);
		Bdisp_DrawLineVRAM(x2,y1,x2,y2);
		Bdisp_DrawLineVRAM(x2,y2,x1,y2);
		Bdisp_DrawLineVRAM(x1,y2,x1,y1);
		// Contours internes
		Bdisp_DrawLineVRAM(x1+2,y1+2,x2-2,y1+2);
		Bdisp_DrawLineVRAM(x2-2,y1+2,x2-2,y2-2);
		Bdisp_DrawLineVRAM(x2-2,y2-2,x1+2,y2-2);
		Bdisp_DrawLineVRAM(x1+2,y2-2,x1+2,y1+2);
	}
#endif

#ifdef WINDOWS_2
	void windows_2(int x1, int y1, int x2, int y2)
	{
		// Contours externes
		Bdisp_DrawLineVRAM(x1,y1,x2,y1);
		Bdisp_DrawLineVRAM(x2,y1,x2,y2);
		Bdisp_DrawLineVRAM(x2,y2,x1,y2);
		Bdisp_DrawLineVRAM(x1,y2,x1,y1);
		// Contours internes
		Bdisp_DrawLineVRAM(x1+2,y1+2,x2-2,y1+2);
		Bdisp_DrawLineVRAM(x2-2,y1+2,x2-2,y2-2);
		Bdisp_DrawLineVRAM(x2-2,y2-2,x1+2,y2-2);
		Bdisp_DrawLineVRAM(x1+2,y2-2,x1+2,y1+2);
		// Angles
		Bdisp_DrawLineVRAM(x1-1,y1-1,x1+5,y1-1);
		Bdisp_DrawLineVRAM(x1-1,y1-1,x1-1,y1+5);
		Bdisp_DrawLineVRAM(x1-1,y2+1,x1+5,y2+1);
		Bdisp_DrawLineVRAM(x1-1,y2+1,x1-1,y2-4);
		Bdisp_DrawLineVRAM(x2+1,y1-1,x2-4,y1-1);
		Bdisp_DrawLineVRAM(x2+1,y1-1,x2+1,y1+5);
		Bdisp_DrawLineVRAM(x2+1,y2+1,x2-4,y2+1);
		Bdisp_DrawLineVRAM(x2+1,y2+1,x2+1,y2-4);
	}
#endif

#ifdef WINDOWS_3
	void windows_3(int x1, int y1, int x2, int y2)
	{
		// Contours externes
		Bdisp_DrawLineVRAM(x1,y1,x2,y1);
		Bdisp_DrawLineVRAM(x2,y1,x2,y2);
		Bdisp_DrawLineVRAM(x2,y2,x1,y2);
		Bdisp_DrawLineVRAM(x1,y2,x1,y1);
		// Contours internes
		Bdisp_DrawLineVRAM(x1-1,y1+1,x1+1,y1-1);
		Bdisp_DrawLineVRAM(x1-1,y1,x1,y1-1);
		Bdisp_DrawLineVRAM(x1-2,y1,x1,y1-2);
		Bdisp_DrawLineVRAM(x1-1,y2-1,x1+1,y2+1);
		// Angles
		Bdisp_DrawLineVRAM(x1-1,y2,x1,y2+1);
		Bdisp_DrawLineVRAM(x1-2,y2,x1,y2+2);
		Bdisp_DrawLineVRAM(x2-1,y1-1,x2+1,y1+1);
		Bdisp_DrawLineVRAM(x2,y1-1,x2+1,y1);
		Bdisp_DrawLineVRAM(x2,y1-2,x2+2,y1);
		Bdisp_DrawLineVRAM(x2-1,y2+1,x2+1,y2-1);
		Bdisp_DrawLineVRAM(x2,y2+1,x2+1,y2);
		Bdisp_DrawLineVRAM(x2,y2+2,x2+2,y2);
	}
#endif

#ifdef WINDOWS_4
	void windows_4(int x1, int y1, int x2, int y2)
	{
		int milieu, longueur;
		// Contours externes
		Bdisp_DrawLineVRAM(x1,y1,x2,y1);
		Bdisp_DrawLineVRAM(x2,y1,x2,y2);
		Bdisp_DrawLineVRAM(x2,y2,x1,y2);
		Bdisp_DrawLineVRAM(x1,y2,x1,y1);
		// Contours internes
		Bdisp_DrawLineVRAM(x1+2,y1+2,x2-2,y1+2);
		Bdisp_DrawLineVRAM(x2-2,y1+2,x2-2,y2-2);
		Bdisp_DrawLineVRAM(x2-2,y2-2,x1+2,y2-2);
		Bdisp_DrawLineVRAM(x1+2,y2-2,x1+2,y1+2);
		// Lignes internes
		milieu=x1+x2/2;
		longueur=x1-x2/5;
		Bdisp_DrawLineVRAM(milieu-longueur,y1+1,milieu+longueur,y1+1);
		Bdisp_DrawLineVRAM(milieu-longueur,y2-1,milieu+longueur,y2-1);
		milieu=(y1+y2)/2;
		longueur=(y1-y2)/5;
		Bdisp_DrawLineVRAM(x1+1,milieu+longueur,x1+1,milieu-longueur);
		Bdisp_DrawLineVRAM(x2-1,milieu+longueur,x2-1,milieu-longueur);
	}
#endif